
# [U[̓͂estcmdp̈ɕϊNX
class StringParser
  attr_reader :search_phrase, :attribute_condition_ary

  def initialize(arg) 
    inputted_str = arg.dup
    @search_phrase = ''
    @attribute_condition_info_ary = []

    # () ŃO[vꂽ  
    while inputted_str =~ /([^ @]+:\(.+\))/
      add_attribute( $1, false )
      inputted_str.sub!(/([^ @]+:\(.+\))/, '')
    end

    while inputted_str =~ /([^ @]+:\".*\")/
      add_attribute( $1, false )
      inputted_str.sub!(/([^ @]+:\".*\")/, '')
    end

    # "" ň͂܂ꂽt[Y
    while inputted_str =~ /.*\"(.*)\".*/
      if @search_phrase.length > 0
        @search_phrase += ' AND '
      end

      start_pos = inputted_str.index('"')
      end_pos = inputted_str.index('"', start_pos + 1)

      @search_phrase += inputted_str[ start_pos + 1 .. end_pos - 1 ]
      inputted_str.slice!( start_pos .. end_pos )
    end
  
    strs = inputted_str.split(/ |@/)
    or_flag = false

    strs.each { |str|
      next  if str == nil || str.length == 0
      
      if str.index(':') != nil
        add_attribute(str, or_flag)
        or_flag = false
        next
      end
    
      if str == 'OR'
        or_flag = true
        next
      end
        
      if @search_phrase.length > 0
        if str[0].chr == '-' 
          @search_phrase += ' ANDNOT '  
          str = str[1, str.length]
        else
          if or_flag 
            @search_phrase += ' OR '
            or_flag = false
          else
            @search_phrase += ' AND '  
          end
        end
      end
      
      if str =~ /^(.*)\*$/
        @search_phrase += ' '  if @search_phrase.length > 0
        @search_phrase += "[BW] "
        str = $1
      elsif str =~ /^\*(.*)$/
        @search_phrase += ' '  if @search_phrase.length > 0
        @search_phrase += "[EW] "
        str = $1
      end
      
      @search_phrase += str
    }
    
    @search_phrase = '[UVSET]'  if @search_phrase.length == 0
    
    # ͂̏񂩂AHyper Estraierp̑𐶐
    if @attribute_condition_info_ary.size > 0
      @attribute_condition_ary = []
      @attribute_condition_info_ary.each { |info| 
        @attribute_condition_ary << "#{info.attribute_name} #{info.operator} #{info.search_string}"
      }
    end
  end

  # ͏郁\bh
  # str : [U͂
  # or_flag : ̒̕Õg[NA'OR'ȂtrueBȊȌꍇfalseB
  def add_attribute(str, or_flag)
    str_ary = str.split(':')
    
    return  if str_ary == nil || str_ary.size <= 1
    
    attr = str_ary[0]
    val = str_ary[1]
    
    # ͈͎w̏
    if attr == 'after'
      time = Time.local( *val.split('/') )
      cond = AttributeSearchCondition.new
      cond.attribute_name = '@cdate'
      cond.operator = 'NUMGE'
      cond.search_string = time.to_i
      @attribute_condition_info_ary << cond
      return
    elsif attr == 'before'
      time = Time.local( *str_ary[1].split('/') )
      time = time + 86400
      cond = AttributeSearchCondition.new
      cond.attribute_name = '@cdate'
      cond.operator = 'NUMLT'
      cond.search_string = time.to_i
      @attribute_condition_info_ary << cond
      return
    end
    
    # A1ڂ'-'ȂANOT
    if attr[0].chr == '-' || val[0].chr == '-'
      cond = AttributeSearchCondition.new
    
      if attr[0].chr == '-'
        attr = attr[1, attr.length]
      elsif val[0].chr == '-'
        val = val[1, val.length]
      else
        raise 'unexpected state'
      end
      
      cond.attribute_name = attr
      cond.operator = '!ISTRINC'
      cond.search_string = val
      @attribute_condition_info_ary << cond
      return
    end

    # ORȂAłɓo^Ăɒǉ
    if or_flag
      @attribute_condition_info_ary.each { |cond|
        if cond.attribute_name == attr && cond.operator.index('!') == nil
          cond.operator = 'ISTRRX'
          cond.search_string += '|' + val

          return
        end
      }
    end
    
    # O[vAPꂪw肳Ăꍇ́AHyper Estraierp̕ɍւB
    if val =~ /^\((.*)\)$/
      val = $1
      ary = val.split(/ |@/)
      val = ''
      or_flag = false

      ary.each { | one_attr_val |
        next  if one_attr_val == nil || one_attr_val.length == 0

        if one_attr_val == 'OR'
          or_flag = true 
          next
        end

        if one_attr_val[0].chr == '-'
          cond = AttributeSearchCondition.new
          cond.attribute_name = attr
          cond.operator = '!ISTRINC'
          cond.search_string = one_attr_val[1, one_attr_val.length]
          @attribute_condition_info_ary << cond
          next
        end

        if or_flag
          if @attribute_condition_info_ary.size >= 1
            last_cond = @attribute_condition_info_ary.last
            last_cond.operator = "ISTRRX"
            last_cond.search_string += '|' + one_attr_val
          end
        
          or_flag = false
          next
        end
      
        cond = AttributeSearchCondition.new
        cond.operator = 'ISTRINC'
        cond.attribute_name = attr
        cond.search_string = one_attr_val
        @attribute_condition_info_ary << cond
      }
      
      return
    end
    
    if val =~ /\"(.*)\"/
      val = $1
    end

    cond = AttributeSearchCondition.new
    cond.operator = 'ISTRINC'
    cond.attribute_name = attr
    cond.search_string = val
    @attribute_condition_info_ary << cond
  end
end


# ̏ێNX
class AttributeSearchCondition
  attr_accessor :attribute_name, :operator, :search_string


end
